data Nat : Set 
{
  zero : Nat;
  succ : Nat -> Nat
}

codata Stream : Set 
{
  cons : Nat -> Stream -> Stream
}

data P : Stream -> Set
{
  any : (str : Stream) -> P str;
  inc : (str : Stream) -> (n : Nat) -> P str -> P (cons n str)
}

cofun zeros : Stream
{
 zeros = cons zero zeros 
}

fun id : P zeros -> P zeros
{
 id x = x
}

data Prod : Set -> Set -> Set
{
  pair : (A : Set) -> (B : Set) -> (a : A) -> (b : B) -> Prod A B
}

cofun Tup : Set
{
  Tup = Prod Nat Tup
}

cofun ones : Tup
{
  ones = pair Nat Tup (succ zero) ones
}

cofun X : Set
{
  X = X
}

fun idX : X -> X
{
  idX x = x
}

cofun x : X
{
  x = idX x
}

cofun y : X
{
  y = zero
}