-- 2010-07-09 Workshop on Dependently Typed Programming DTP-10

data Nat : Set
{ zero : Nat
; succ : Nat -> Nat
}

data Vec ++(A : Set) : Nat -> Set
{ vnil  : Vec A zero
; vcons : [n : Nat] -> (vhead : A) -> (vtail : Vec A n) -> Vec A (succ n)
}

-- ok, but boring
fun length0 : [A : Set] -> (n : Nat) -> Vec A n -> <n : Nat>
{ length0 A n v = n
}

-- cannot use irrelevant function argument [n : Nat]
fail fun length1 : [A : Set] -> [n : Nat] -> Vec A n -> <n : Nat>
{ length1 A n v = n 
}

-- cannot use irrelevant constructor argument
fail fun length2 : [A : Set] -> [n : Nat] -> Vec A n -> <n : Nat>
{ length2 A .zero (vnil .A) = zero
; length2 A .(succ n) (vcons .A n a v) = succ n
}

-- recursive solution, extracts to  length : List A -> Nat
fun length : [A : Set] -> [n : Nat] -> Vec A n -> <n : Nat>
{ length A .zero (vnil .A) = zero
; length A .(succ n) (vcons .A n a v) = succ (length A n v)
}

